const gulp = require('gulp')
const path = require('path')
const replace = require('gulp-replace')
const babelScriptTag = require('gulp-babel-script-tag')
const buildWebpack = require('./utils/webpack')
const { PATH, LOADCACHE } = require('./config')

gulp
  .task("compile/index", (cb) => {
    let lib_index = 0
    gulp
      .src(`index.html`)
      .pipe(replace(/\<\/head\>/ig, function (head) {
        return LOADCACHE.join('\n') + '\n' + head
      }))
      .pipe(babelScriptTag())
      .pipe(replace(/\<script .*?src=\"(.+?)\"/ig, function (script, src) {
        lib_index++
        let lib_path = path.parse(src)

        buildWebpack(src, () => {
          lib_index--
          if (lib_index === 0) {
            cb()
          }
        })

        return src.match(/^\w+\:/) === null && src.indexOf('//') !== 0
          ? script.replace(src, PATH.root + (lib_path.dir ? lib_path.dir + '/' : '') + lib_path.base)
          : script
      }))
      .pipe(gulp.dest(PATH.pages))
  })
