const gulp = require('gulp')
const chalk = require('chalk')
const ora = require('ora')
const watch = require('gulp-watch')
const ts = require('gulp-typescript')
const babel = require('gulp-babel')
const uglify = require('gulp-uglify')
const toCJSTransformer = require('gulp-imports-to-commonjs')
const { PATH, JS_SOURCE, TS_SOURCE } = require('./config')

gulp
  .task("compile/script", (cb) => {
    const spinner = ora(chalk.white.bgGreen.bold('compile/script'))
    spinner.start()

    let stream = gulp.src(JS_SOURCE)
      .on('end', () => {
        spinner.stop()
        cb()
      })
      .pipe(watch(JS_SOURCE))
      .pipe(toCJSTransformer())
      .pipe(babel())

    if (process.env.NODE_ENV === 'production') {
      stream = stream.pipe(uglify())
    }

    stream.pipe(gulp.dest(PATH.static))
  })

// bulid amd js
gulp
  .task("compile/script.ts", (cb) => {
    const spinner = ora(chalk.white.bgGreen.bold('compile/script/ts'))
    spinner.start()

    let stream = gulp.src(TS_SOURCE)
      .on('end', () => {
        spinner.stop()
        cb()
      })
      .pipe(watch(TS_SOURCE))
      .pipe(ts({
        declaration: true
      }))
      .pipe(toCJSTransformer())
      .pipe(babel())

    if (process.env.NODE_ENV === 'production') {
      stream = stream.pipe(uglify())
    }

    stream.pipe(gulp.dest(PATH.static))
  })
