const gulp = require('gulp')
const watch = require('gulp-watch')
const babelScriptTag = require('gulp-babel-script-tag')
const htmlmin = require('gulp-html-minifier')
const jsonp = require('./utils/jsonp')
const { PATH, TEMPLATE_SOURCE } = require('./config')

gulp
  .task("compile/source", (cb) => {
    gulp
      .src(TEMPLATE_SOURCE)
      .on('end', cb)
      .pipe(watch(TEMPLATE_SOURCE))
      .pipe(babelScriptTag())
      .pipe(htmlmin({collapseWhitespace: true}))
      .pipe(jsonp())
      .pipe(gulp.dest(PATH.static))
  })
