const gulp = require('gulp')
const chalk = require('chalk')
const ora = require('ora')
const watch = require('gulp-watch')
const { PATH } = require('./config')
const STATIC_SOURCE = [`{components,modules}/**/*.{json,svg,jpg,jpeg,gif,png,webp,bmp,tpg,mp4,mp3,ogg,eot,woff,ttf}`]

gulp
  .task("copy/static", (cb) => {
    const spinner = ora(chalk.white.bgGreen.bold('copy/static'))
    spinner.start()

    gulp
      .src(STATIC_SOURCE)
      .on('end', () => {
        spinner.stop()
        cb()
      })
      .pipe(watch(STATIC_SOURCE))
      .pipe(gulp.dest(PATH.static))
  })