const fs = require('fs')
const path = require('path')
const chalk = require('chalk')
const webpack = require("webpack")
const miniLib = require('./mini-lib')
const { PATH, webpack_config } = require('../config')

module.exports = (src, cb) => {
  let lib_path = path.parse(src)
  let lib_path_dir = (lib_path.dir ? lib_path.dir + '/' : '')
  let config = webpack_config
  let config_path = `${PATH.pwd}/${lib_path_dir}webpack.config.js`
  let output_path = PATH.static + lib_path_dir
  let output_file = output_path + lib_path.base

  config.mode = process.env.NODE_ENV == 'production' ? 'production' : 'development'

  if (fs.existsSync(config_path)) {
    config = require(config_path)
  }

  config.entry = {
    main: `${PATH.pwd}/${src}`
  }

  config.output = {
    path: output_path,
    filename: lib_path.base
  }

  webpack(config, (err, stats) => {
    if (err || stats.hasErrors()) {
      console.log(chalk.red('× webpack error: ' + src + (err ? ' > ' + err : '')))
    }
    miniLib(output_file)
    cb()
  })
}
