'use strict'
const ora = require('ora')
const co = require('co')
const prompt = require('co-prompt')
const config = require('../templates')
const chalk = require('chalk')
const download = require('download-git-repo')

module.exports = () => {

  co(function* () {
    // 处理用户输入

    let tplName = yield prompt(chalk.green('?') + chalk.bold(' Template name: '))

    if (!config.tpl[tplName]) {
      console.log(chalk.red(`\n Template[${chalk.blue(tplName)}] does not exit!`))
      console.log(`\n View all template: ${chalk.green('ioi list')}`)
      process.exit()
    }

    let projectName = yield prompt(chalk.green('?') + chalk.bold(' Project name: '))
    let projectPlace = './'

    const gitPlace = config.tpl[tplName].repository
    const gitBranch = config.tpl[tplName].branch
    const spinner = ora('Downloading template...')

    spinner.start()

    download(`${gitPlace}#${gitBranch}`, `${projectPlace}/${projectName}`, (err) => {
      spinner.stop()
      if (err) {
        console.log(chalk.red(err))
        process.exit()
      }
      console.log(chalk.green('\n √ New project has been initialized successfully!'))
      console.log(`\n ${chalk.green('cd')} ${projectName} ${chalk.blue('&&')} ${chalk.green('npm')} install \n`)
      require("./build/update-version")(projectName)
      process.exit()
    })
  })
}