// 'use strict'
// const config = require('../templates')

// module.exports = () => {
//   console.log(config.tpl)
//   process.exit()
// }

const Table = require('cli-table')
const chalk = require('chalk')

const table = new Table({
  head: ['Template Name', 'Repository', 'Branch'],
  style: {
    head: ['green']
  }
})

function listTable (tplList, lyric) {
  const list = Object.keys(tplList)

  if (list.length) {
    list.forEach((key) => {
      table.push([key, tplList[key]['repository'], tplList[key]['branch']])
      if (table.length === list.length) {
        console.log(table.toString())
        if (lyric) {
          console.log(chalk.green(`\u2714 ${lyric}`))
        }
        process.exit()
      }
    })
  } else {
    console.log(table.toString())
    if (lyric) {
      console.log(chalk.green(`\u2714 ${lyric}`))
    }
    process.exit()
  }
}

let tplList = require('../templates')

module.exports = listTable(tplList.tpl)
